//
//  Example for CWduino kit KT-004 - CW Beacon mode
//
//  2022, KRAIT Technologies
//

#define SPEED   (18)    //Speed in WPM. Default: 18
#define DOTLEN  (1200/SPEED)
#define DASHLEN (3*(1200/SPEED))
#define PAUSE 2         //Time in seconds between transmissions
#define P_CW     4   // Output of the keyer, it triggers TX stage on CWduino

int P_LED = 13;         //Digital pin used to show when the tone is playing. Pin 13 has an attached led on most Arduino boards.

void sendMsg(char*);
void dash();
void dot();

void setup()
{
  pinMode(P_LED, OUTPUT);
  pinMode(P_CW, OUTPUT);
}

void loop()
{
  sendMsg("CWDUINO"); //Remember to replace it with your callsign/message!
  delay(PAUSE*1000); //Delay between repeated messages
}

void dash()
{
  digitalWrite(P_LED, HIGH);
  digitalWrite(P_CW, HIGH);
  delay(DASHLEN);
  digitalWrite(P_LED, LOW);
  digitalWrite(P_CW, LOW);
  delay(DOTLEN);
}

void dot()
{
  digitalWrite(P_LED, HIGH) ;
  digitalWrite(P_CW, HIGH);
  delay(DOTLEN);
  digitalWrite(P_LED, LOW);
  digitalWrite(P_CW, LOW);
  delay(DOTLEN);
}

void sendMsg(char *str)
{
  int i;
  //delay(500);

  for(i=0;i<strlen(str);i++)
  {
    switch (str[i])
    {
    case 'A':
      dot();dash();break;
    case 'B':
      dash();dot();dot();dot();break;
    case 'C':
      dash();dot();dash();dot();break;
    case 'D':
      dash();dot();dot();break;
    case 'E':
      dot();break;
    case 'F':
      dot();dot();dash();dot();break;
    case 'G':
      dash();dash();dot();break;
    case 'H':
      dot();dot();dot();dot();break;
    case 'I':
      dot();dot();break;
    case 'J':
      dot();dash();dash();dash();break;
    case 'K':
      dash();dot();dash();break;
    case 'L':
      dot();dash();dot();dot();break;
    case 'M':
      dash();dash();break;
    case 'N':
      dash();dot();break;
    case 'O':
      dash();dash();dash();break;
    case 'P':
      dot();dash();dash();dot();break;
    case 'Q':
      dash();dash();dot();dash();break;
    case 'R':
      dot();dash();dot();break;
    case 'S':
      dot();dot();dot();break;
    case 'T':
      dash();break;
    case 'U':
      dot();dot();dash();break;
    case 'V':
      dot();dot();dot();dash();break;
    case 'W':
      dot();dash();dash();break;
    case 'X':
      dash();dot();dot();dash();break;
    case 'Y':
      dash();dot();dash();dash();break;
    case 'Z':
      dash();dash();dot();dot();break;
    case ' ':
      delay(DOTLEN*3);break;
    case '.':
      dot();dash();dot();dash();dot();dash();break;
    case ',':
      dash();dash();dot();dot();dash();dash();break;
    case ':':
      dash();dash();dash();dot();dot();break;
    case '?':
      dot();dot();dash();dash();dot();dot();break;
    case '\'':
      dot();dash();dash();dash();dash();dot();break;
    case '-':
      dash();dot();dot();dot();dot();dash();break;
    case '/':
      dash();dot();dot();dash();dot();break;
    case '(':
    case ')':
      dash();dot();dash();dash();dot();dash();break;
    case '\"':
      dot();dash();dot();dot();dash();dot();break;
    case '@':
      dot();dash();dash();dot();dash();dot();break;
    case '=':
      dash();dot();dot();dot();dash();break;
    case '0':
     dash();dash();dash();dash();dash();break;
    case '1':
     dot();dash();dash();dash();dash();break;
    case '2':
     dot();dot();dash();dash();dash();break;
    case '3':
     dot();dot();dot();dash();dash();break;
    case '4':
     dot();dot();dot();dot();dash();break;
    case '5':
     dot();dot();dot();dot();dot();break;
    case '6':
     dash();dot();dot();dot();dot();break;
    case '7':
     dash();dash();dot();dot();dot();break;
    case '8':
     dash();dash();dash();dot();dot();break;
    case '9':
     dash();dash();dash();dash();dot();break;
    }
    delay(3*DOTLEN);
  }
}