//
//  Example for CWduino kit KT-004 - CW Keyer
//
//  2022, KRAIT Technologies
//

#define P_DOT    2   // dot lever of the paddle (tip)
#define P_DASH   3   // dash lever of the paddle (ring)
#define P_CW     4   // Output of the keyer, it triggers TX stage on CWduino
#define SPEED   (18) // Speed in WPM. Default: 18
#define DOTLEN  (1200/SPEED)
#define DASHLEN (3*(1200/SPEED))

int P_LED = 13; //Digital pin used to show when the tone is playing. Pin 13 has an attached led on most Arduino boards.

void setup()
{
  pinMode(P_DOT, INPUT);
  pinMode(P_DASH, INPUT); 
  pinMode(P_LED, OUTPUT);
  pinMode(P_CW, OUTPUT);
  digitalWrite(P_CW, LOW);      // Start with key up
}

void loop()
{
  if(!digitalRead(P_DOT))        // If the dot lever is presssed...
  {
    digitalWrite(P_LED, HIGH);
    key(DOTLEN);                 // ... send a dot at the given speed
    digitalWrite(P_LED, LOW);
    delay(DOTLEN);               //     and wait before sending next
  }
  
  if(!digitalRead(P_DASH))       // If the dash lever is pressed...
  {
    digitalWrite(P_LED, HIGH);
    key(DASHLEN);                // ... send a dash at the given speed
    digitalWrite(P_LED, LOW);
    delay(DOTLEN);               //     and wait before sending next
  }
}

void key(int speed)
{
  digitalWrite(P_CW, HIGH);        // Key down
  for (int i=0; i < (speed); i++)  // Waiting loop
  {
    delay(1);
  }
  digitalWrite(P_CW, LOW);         // Key up
}